var alertDialog = (function () {
    var _queue = [],
        _opts = {
            modal: true,
            resizable: false,
            height: "auto",
            autoOpen: false,
            buttons: {
                OK: function () {
                    $(this).dialog('close');
                    var next = _queue.shift();
                    if (typeof next === 'string') {
                        _dialog.text(next).dialog('open');
                    }
                }
            }
        },
        _dialog = $('<div id="alertDialog" title="Alert!"></div>').dialog(_opts),
        _self = {};

    _self.show = function (message, title) {
        if (_dialog.dialog('isOpen')) {
            _queue.push(String(message));
        }
        else {
            _dialog.text(message).dialog('open');
            if(title) {
                $('#alertDialog').dialog('option', 'title', title);
            }
        }
    }

    return _self;
}());

var confirmDialog = (function () {
    var _queue = [],
        _result = false,
        _opts = {
            modal: true,
            resizable: false,
            height: "auto",
            autoOpen: false,
            buttons: {
                YES: function () {
                    $(this).dialog('close');
                    var next = _queue.shift();
                    if (typeof next === 'string') {
                        _dialog.text(next).dialog('open');
                    }
                    _result = true;
                },
                NO: function () {
                    $(this).dialog('close');
                    var next = _queue.shift();
                    if (typeof next === 'string') {
                        _dialog.text(next).dialog('open');
                    }
                    _result = false;
                }
            }
        },
        _dialog = $('<div id="confirmDialog" title="Confirm"></div>').dialog(_opts),
        _self = {};

    _self.show = function (message, yesPrompt, noPrompt) {
        if (_dialog.dialog('isOpen')) {
            _queue.push(String(message));
        }
        else {
            _dialog.text(message).dialog('open');
        }
    }

    _self.result = function () { return _result; }

    return _self;
}());

var formDialog = (function () {
}());
