// This is a manifest file that'll be compiled into application.js, which will include all the files
// listed below.
//
// Any JavaScript/Coffee file within this directory, lib/assets/javascripts, vendor/assets/javascripts,
// or any plugin's vendor/assets/javascripts directory can be referenced here using a relative path.
//
// It's not advisable to add code directly here, but if you do, it'll appear at the bottom of the
// compiled file. JavaScript code in this file should be added after the last require_* statement.
//
// Read Sprockets README (https://github.com/rails/sprockets#sprockets-directives) for details
// about supported directives.
//
//= require jquery.min
//= #require jquery_ujs
//= require datetimepicker
//= #require ./fullcalendar_timeline
//= #require_tree ./fullcalendar_timeline
//
//= #require jquery-week-calendar
//= #require popper
//= #require bootstrap.min
//= #require_self
//
//= #require ./store
//= #require_tree ./models
//= #require_tree ./controllers
//= #require_tree ./views
//= #require_tree ./helpers
//= #require_tree ./templates
//= #require ./router
//= #require_tree ./routes
//
//= #require_tree .
//

//document.cookie = 'time_zone='+jstz.determine().timezone.name()+';';

/**
 * Adds time to a date. Modelled after MySQL DATE_ADD function.
 * Example: dateAdd(new Date(), 30, 'minute')  //returns 30 minutes from now.
 * https://stackoverflow.com/a/1214753/18511
 *
 * @param date  Date to start with
 * @param interval Number of units of the given interval to add.
 * @param units One of: year, quarter, month, week, day, hour, minute, second
 */
function dateAdd(date, interval, units) {
    var ret = new Date(date); // don't change original date
    var checkRollover = function () { if (ret.getDate() != date.getDate()) ret.setDate(0); };
    switch (units.toLowerCase()) {
        case 'year': ret.setFullYear(ret.getFullYear() + interval); checkRollover(); break;
        case 'quarter': ret.setMonth(ret.getMonth() + 3 * interval); checkRollover(); break;
        case 'month': ret.setMonth(ret.getMonth() + interval); checkRollover(); break;
        case 'week': ret.setDate(ret.getDate() + 7 * interval); break;
        case 'day': ret.setDate(ret.getDate() + interval); break;
        case 'hour': ret.setTime(ret.getTime() + interval * 3600000); break;
        case 'minute': ret.setTime(ret.getTime() + interval * 60000); break;
        case 'second': ret.setTime(ret.getTime() + interval * 1000); break;
        default: ret = undefined; break;
    }
    return ret;
}

Date.prototype.yyyymmdd = function () {
    var mm = this.getMonth() + 1; // getMonth() is zero-based
    var dd = this.getDate();

    return [this.getFullYear(),
    (mm > 9 ? '' : '0') + mm,
    (dd > 9 ? '' : '0') + dd
    ].join('-');
};

Date.prototype.diff = function (otherDate, units) {
    return moment(this).diff(moment(otherDate), units)
};

/**
 *
 * @param {*} d Date to format
 */
function formatDate(d) {
    var date_format_str = d.getFullYear().toString() + "-" + ((d.getMonth() + 1).toString().length == 2 ? (d.getMonth() + 1).toString() : "0" + (d.getMonth() + 1).toString()) + "-" + (d.getDate().toString().length == 2 ? d.getDate().toString() : "0" + d.getDate().toString()) + " " + (d.getHours().toString().length == 2 ? d.getHours().toString() : "0" + d.getHours().toString()) + ":" + ((parseInt(d.getMinutes() / 5) * 5).toString().length == 2 ? (d.getMinutes()).toString() : "0" + (d.getMinutes()).toString()); //+":00";
    return date_format_str;
}

/**
 *
 * @param {*} yr Year to check
 */
function isLeapYear(yr) {
    return (yr % 400) ? ((yr % 100) ? ((yr % 4) ? false : true) : false) : true;
}

/**
 * Check if a data falls between two other dates
 * https://stackoverflow.com/questions/16080378/check-if-one-date-is-between-two-dates-javascript
 *
 * @param from  Range start date
 * @param to    Range end date
 * @param check Date to check
 */
function dateCheck(from, to, check) {
    var fDate, tDate, cDate;
    fDate = Date.parse(from);
    tDate = Date.parse(to);
    cDate = Date.parse(check);

    if ((cDate <= tDate && cDate >= fDate)) {
        return true;
    }
    return false;
}
