$(document).ready(function() {

    $("#kendoui_calendar").kendoScheduler({
        date: new Date(),
        majorTimeHeaderTemplate: kendo.template("<strong>#=kendo.toString(date, 'HH:mm')#</strong>"),
        // startTime: new Date("2018/7/21 00:00"),
        // endTime: new Date("2018/7/21 24:00"),
        eventHeight: 10,
        selectable: false,
        // editable: false,
        majorTick: 60,
        minorTickCount: 1,
        // currentTimeMarker: {
        //    useLocalTimezone: true
        //   },
        timezone: "Etc/UTC",
        // views: ["timeline", "timelineWeek", "timelineWorkWeek", {
        //         type: "timeline",
        //         majorTick: 60
        // }],
        views: [
            "day",
            "workWeek",
            "week",
            { type: "month", selected: true },
            "agenda",
            { type: "timeline", eventHeight: 50 },
        ],

        // group: {
        //     resources: ["Rooms", "Attendees"],
        //     orientation: "vertical"
        // },
        // resources: [{
        //         field: "roomId",
        //         name: "Rooms",
        //         title: "Room",
        //         dataSource: [
        //                 { text: "Resource 1",  value: 1,  color: "#6eb3fa" },
        //                 { text: "Resource 2",  value: 2,  color: "#f58a8a" },
        //                 { text: "Resource 3",  value: 3,  color: "#6eb3fa" },
        //                 { text: "Resource 4",  value: 4,  color: "#f58a8a" },
        //                 { text: "Resource 5",  value: 5,  color: "#6eb3fa" },
        //                 { text: "Resource 6",  value: 6,  color: "#f58a8a" },
        //                 { text: "Resource 7",  value: 7,  color: "#6eb3fa" },
        //                 { text: "Resource 8",  value: 8,  color: "#f58a8a" },
        //                 { text: "Resource 9",  value: 9,  color: "#6eb3fa" },
        //                 { text: "Resource 10", value: 10, color: "#f58a8a" }
        //         ],
        // }],

        dataSource: {
            batch: true, // Enable batch updates
            transport: {
                read: {
                    url: "/resource_planner/events.json",
                    dataType: "json"
                },
                // update: {
                //     url: "/resource_planner/event.json",
                //     dataType: "json"
                // },
                // create: {
                //     url: "/resource_planner/event.json",
                //     dataType: "json"
                // },
                // destroy: {
                //     url: "/resource_planner/event.json",
                //     dataType: "json"
                // },
                parameterMap: function(options, operation) {
                    if (operation !== "read" && options.models) {
                        return {models: kendo.stringify(options.models)};
                    }
                }
            },
            schema: {
                model: {
                    id: "taskId",
                    fields: {
                        taskId: { from: "id", type: "number" },
                        title: { from: "name", defaultValue: "No title" },
                        // description: { from: "description" },
                        start: { type: "date", from: "start_at", validation: { required: true } },
                        end: { type: "date", from: "end_at", validation: { required: true } },
                        // startTimezone: { from: "StartTimezone" },
                        // endTimezone: { from: "EndTimezone" },
                        // recurrenceId: { from: "RecurrenceID" },
                        // recurrenceRule: { from: "RecurrenceRule" },
                        // recurrenceException: { from: "RecurrenceException" },
                        isAllDay: { type: "boolean", from: "all_day" },
                    }
                }
            }
        },

    });

});
