//
// FullcalendarTimeline - Highlighter bar manipulation controls
//

// Initialise timeline manipulation controls
FullcalendarTimeline.prototype.initialiseHighlighterBarManipulationControls = function () {
  // Mechanism to pass (this) to the handlers
  var fullCalendarTimelineObject = this;

  // Initialise _eventsArray
  this._eventsArray = [];
  this._eventsArray.push({});

  // Other instance data
  this._startingDate = null;
  this._endingDate = null;
  this._flag = null;
  this._zoomed = null;
  this._noEndDateDuration = 6; // in months

  /******************************************** EVENT HANDLERS ***********************************************/

  this.getFormField(formField().DTSTART).on('change', function () {
    // if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
    //   fullCalendarTimelineObject.singleEvevenInputStatus('start_date');
    // } else {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    // }
  });

  this.getFormField(formField().DTSTART).on('input', function () {
    // if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
    //   fullCalendarTimelineObject.singleEvevenInputStatus('start_date');
    // } else {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    // }
  });

  this.getFormField(formField().ALLDAY).on('click', function () {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
  });

  this.getFormField(formField().TZOFFSETFROM).on('change', function () {
  });

  this.getFormField(formField().TZOFFSETFROM).on('input', function () {
  });

  // duration
  this.getFormField(formField().DURATION).on('change', function () {
    // if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
    //   fullCalendarTimelineObject.singleEvevenInputStatus('duration');
    // } else {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    // }
  });

  this.getFormField(formField().DURATION).on('input', function () {
    // if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
    //   fullCalendarTimelineObject.singleEvevenInputStatus('duration');
    // } else {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    // }
  });

  this.getFormField(formField().DURATION_UNITS).on('change', function () {
    // if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
    //   fullCalendarTimelineObject.singleEvevenInputStatus('duration');
    // } else {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    // }
  });

  // end_date
  this.getFormField(formField().DTEND).on('change', function () {
    // if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
    //   fullCalendarTimelineObject.singleEvevenInputStatus('end_date');
    // } else {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    // }
  });

  this.getFormField(formField().DTEND).on('input', function () {
    // if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
    //   fullCalendarTimelineObject.singleEvevenInputStatus('end_date');
    // } else {
    fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    // }
  });

  this.getFormField(formField().TZOFFSETTO).on('change', function () {
  });

  this.getFormField(formField().TZOFFSETTO).on('input', function () {
  });

  // resource_planner_event_rrule (recurence rule select)
  this.getFormField('#resource_planner_event_rrule').on('change', function () {
    // Remove existing 'highlighter' bars
    if (fullCalendarTimelineObject._timelineViewWrapper.find('.highlighter').length != 0) {
      fullCalendarTimelineObject._timelineViewWrapper.find('.highlighter').remove();
    }

    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_rrule').on('input', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.recurring_event_data.daily input').on('input', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.recurring_event_data.weekly input').on('input', function () {       // every_n_week(s) field was typed
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField(".day_buttons label").on("click", function () {         // one of the days of the week was selected
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.recurring_event_data.monthly input').on('input', function () {               // every_n_week(s) field was typed
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_bymonthday').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_bymonthday_day').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField(".monthly_day_buttons label").on("click", function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_bymonthday_day').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.range_of_recurence input').on('input', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_until_repeat_until_date').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

}

//=============================================================================
// Return highlighter object
//=============================================================================
FullcalendarTimeline.prototype.getHighlighterBar = function () {
  return this._timelineViewWrapper.find('#highlighter');
}
//
// Common/Helper functions
//

FullcalendarTimeline.prototype.getEventWindowHeight = function () {
  var view = this._fullcalendarObject.view;
  return view.timeAxisTbody.clientHeight;
}

FullcalendarTimeline.prototype.getEventWindowWidth = function () {
  var view = this._fullcalendarObject.view;
  return view.timeAxisTbody.clientWidth;
}

FullcalendarTimeline.prototype.getEventWindowHours = function () {
  var view = this._fullcalendarObject.view;
  var start = view.currentStart;
  var end = view.currentEnd;
  var days = end.diff(start, 'days');
  var eventWindowHours = 24 * days;
  return eventWindowHours;
}

//=============================================================================
// Calculates the UTC Offsets
//=============================================================================
FullcalendarTimeline.prototype.tzOffset = function () {
  var startTZ = this._formData.resource_planner_event_dtstart_timezone;
  var startZone = moment;
  // Set the Timezone
  startZone.tz.setDefault(startTZ)();
  // Total UTC offset in milliseconds
  var utcOffset = startZone().utcOffset() * 60000;

  return utcOffset;
}

//=============================================================================
FullcalendarTimeline.prototype.getEventDurationHours = function () {
  var view = this._fullcalendarObject.view;

  var viewDuration = view.currentEnd.diff(view.currentStart, 'hours');
  var eventDurationHours = viewDuration * this.getHighlighterBar().width() / this.getEventWindowWidth();

  return eventDurationHours;
}

//=============================================================================
FullcalendarTimeline.prototype.setHighlighterBarWidth = function (duration, durationUnits) {
  var view = this._fullcalendarObject.view;

  var eventDurationHours;
  switch (durationUnits) {
    case 'day':
      eventDurationHours = duration * 24.0;
      break;
    case 'hour':
      eventDurationHours = duration;
      break;
    case 'minute':
      eventDurationHours = duration / 60.0;
      break;
    default:
      eventDurationHours = duration / 60.0;
  }

  var viewDuration = view.currentEnd.diff(view.currentStart, 'hours');
  var width = this.getEventWindowWidth() * eventDurationHours / viewDuration;

  this.getHighlighterBar().css('width', width);

  return width;
}

//=============================================================================
//Function is triggered by either DRAG or RESIZE events
FullcalendarTimeline.prototype.onHighlighterBarUpdate = function (event, ui, obj) {
  var isRTL = (this._fullcalendarObject.getOption('dir') == 'rtl');
  var view = this._fullcalendarObject.view;
  var viewStartDate = new Date(view.currentStart);

  var eventStartTimeHours;
  var eventEndTimeHours;
  var viewDuration = view.currentEnd.diff(view.currentStart, 'hours');
  var eventDurationHours = viewDuration * obj.width() / this.getEventWindowWidth();

  if (isRTL) {
    eventEndTimeHours = this.getEventWindowHours() - (this.getEventWindowHours() * ui.position.left / this.getEventWindowWidth());
    eventStartTimeHours = eventEndTimeHours - eventDurationHours;
  } else {
    eventStartTimeHours = this.getEventWindowHours() * ui.position.left / this.getEventWindowWidth();
  }

  // Date object methods
  // setDate()	Sets the day of the month of a date object
  // setFullYear()	Sets the year of a date object
  // setHours()	Sets the hour of a date object
  // setMilliseconds()	Sets the milliseconds of a date object
  // setMinutes()	Set the minutes of a date object
  // setMonth()	Sets the month of a date object

  var startDate = dateAdd(viewStartDate, parseInt(eventStartTimeHours / 24), 'day');
  startDate.setHours(Math.floor(eventStartTimeHours % 24));
  startDate.setMinutes(60 * (eventStartTimeHours % 1).toFixed(10));

  var id = obj.attr('id');
  var eventIndex = id.split('-')[1];
  var duration = getDurationInUnits(eventDurationHours, this._eventsArray[eventIndex].durationUnits);
  this._eventsArray[eventIndex].startDate = moment(startDate).format();
  this._eventsArray[eventIndex].eventDuration = duration.toString();
  this._eventsArray[eventIndex].endDate = dateAdd(this._eventsArray[eventIndex].startDate, this._eventsArray[eventIndex].eventDuration, this._eventsArray[eventIndex].durationUnits);
  this._eventsArray[eventIndex].isDirty = true;

  if (this.noReccurence()) {
    this.getFormField(formField().DURATION).val(duration);
    var end_date = dateAdd(startDate, duration, this._eventsArray[eventIndex].durationUnits);
    this.getFormField(formField().DTEND).val(formatDate(end_date));
    this.getFormField(formField().DTSTART).val(formatDate(startDate));
  }
}

/*========================================================================================================*/

FullcalendarTimeline.prototype.noReccurence = function () {
  if ($.trim(this.getFormField('#resource_planner_event_rrule').val()) == 'no_repeat') {
    return true; // all required fields are present
  }
}

//=============================================================================
//function triggered when '.date-field' or DURATION fields changed
// FullcalendarTimeline.prototype.renderHighlighterBar = function (trigger) {
//   var fullCalendarTimelineObject = this;
// }

//=============================================================================
// handle single event input
// FullcalendarTimeline.prototype.singleEvevenInputStatus = function (trigger) {

//   var start_date = $.trim(this.getFormField(formField().DTSTART).val());
//   var end_date = $.trim(this.getFormField(formField().DTEND).val());
//   var duration = $.trim(this.getFormField(formField().DURATION).val());
//   var durationUnits = this._formData.duration_units;

//   if (trigger == 'start_date') {
//     if (end_date !== '') {
//       end_date = new Date(end_date);
//       start_date = new Date(start_date);
//       if (end_date.getTime() <= start_date.getTime()) {
//         end_date = this.getFormField(formField().DTSTART).val();
//         end_date = new Date(end_date);
//         this.getFormField(formField().DTEND).val(formatDate(end_date));
//         duration = '';
//         this.getFormField(formField().DURATION).val(duration);
//         return false;
//       } else {
//         var durationHours = moment(end_date).diff(start_date, 'seconds') / (60 * 60);
//         duration = this.renderDuration(durationHours);
//       }
//     } else {
//       if (duration !== '') {
//         end_date = dateAdd(start_date, duration, durationUnits);
//         this.getFormField(formField().DTEND).val(formatDate(end_date));
//       }
//     }

//     if (end_date == '' && duration == '') {
//       return false;
//     }
//   }

//   if (trigger == 'end_date') {
//     end_date = new Date(end_date);
//     start_date = new Date(start_date);
//     if (end_date.getTime() <= start_date.getTime()) {
//       end_date = this.getFormField(formField().DTSTART).val();
//       end_date = new Date(end_date);
//       this.getFormField(formField().DTEND).val(formatDate(end_date));
//       duration = '';
//       this.getFormField(formField().DURATION).val(duration);
//       return false;
//     }
//     var durationHours = moment(end_date).diff(start_date, 'seconds') / (60 * 60);
//     duration = this.renderDuration(durationHours);
//   }

//   if (trigger == 'duration') {
//     if (start_date !== '' && duration !== '') {
//       end_date = dateAdd(start_date, duration, durationUnits);
//       this.getFormField(formField().DTEND).val(formatDate(end_date));
//     } else {
//       return false;
//     }
//   }

//   var viewStartDate = moment(start_date).format();
//   var viewEndDate = moment(end_date).format();

//   var eventsArray = [];
//   eventsArray.push({});
//   eventsArray[0].startDate = moment(start_date).format();
//   eventsArray[0].eventDuration = duration;
//   eventsArray[0].durationUnits = durationUnits;

//   for (var i = 0; i < eventsArray.length; i++) {
//     eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
//     eventsArray[i].initialStartDate = eventsArray[i].startDate;
//     eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
//     eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
//     eventsArray[i].isDirty = false;
//   }

//   this._eventsArray = eventsArray;
//   this._startingDate = viewStartDate;
//   this._endingDate = viewEndDate;
//   this._flag = true;
//   this._zoomed = true;

//   this.renderEvents(eventsArray, viewStartDate, viewEndDate);

// } // End of handle singel event input

/*========================================================================================================*/
/*  check presence of all required fields for recurence                                                  */
/*________________________________________________________________________________________________________*/
FullcalendarTimeline.prototype.recurenceInputStatus = function (recurencePattern) {

  // clear previous rendered evenets
  if (this._timelineViewWrapper.find('.highlighter').length != 0) {
    this._timelineViewWrapper.find('.highlighter').remove();
  }
  //this.getFormField('.highlighter').remove();

  this.timeZoneConverter();
  var startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
  var start_date = this._formData.start_date;
  //var start_date = $.trim(this.getFormField(formField().DTSTART).val());
  start_date = moment.tz(start_date, startTimeZone);
  var endTimeZone = this._formData.resource_planner_event_dtend_timezone;
  var end_date = $.trim(this.getFormField(formField().DTEND).val());
  end_date = moment.tz(end_date, endTimeZone);

  var duration = $.trim(this.getFormField(formField().DURATION).val());
  var durationUnits = this._formData.duration_units;

  if (start_date == '' || duration == '' || durationUnits == '') {
    // some important fields are missing
    return false;
  }

  // This object will be passed over to the prepareEvents Function
  var recurenceObject = {
    startDate: new Date(start_date),
    eventDuration: duration,
    durationUnits: durationUnits,
    howOften: '',     // Every how many days/weeks/months ?
    when: [],         // Array including the week days, or month days (02, 07, 15,...)
    nrOfEvents: '',   // Number of events
    endDate: new Date(end_date), // Ending date, if specified
    everyWeekDayChecked: '', // every_weekday button checked ?
  }

  var i;
  var values;

  // Check the presence of the recurence pattern section
  switch (recurencePattern) {

    case 'no_repeat':
      recurenceObject.howOften = 1;
      break;

    case 'daily':                                                         // check the presence of the DAILY recurence pattern fields
      var buttonChecked = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
      if (buttonChecked[0].checked) {        // is every_n_days button is checked...
        recurenceObject.everyWeekDayChecked = false;
        var nrDays = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count').val(); // every_n_days button is checked
        values = parseInt(nrDays);
        if (isNaN(values)) {
          return false;                                              // 'n' of every 'n' days is missing
        } else {
          recurenceObject.howOften = values;
          break;                                                       // 'n' of every 'n' days is present
        }
      } else {                                                           // every_n_days button is not checked
        buttonChecked = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
        if (buttonChecked[0].checked) {                                 // is every_weekday butoon is checked
          this.getFormField('.recurring_event_data.daily input#resource_planner_event_count').val(''); // every_n_days button is not checked
          recurenceObject.everyWeekDayChecked = true;
          recurenceObject.howOften = 1;
          break;                                                         // every_weekday butoon is checked
        } else {
          return false;                                                  // every_weekday butoon is not checked
        }
      }

    case 'weekly':                                                        // check the presence of the WEEKLY recurence pattern fields
      var every_n_weeks = this.getFormField('.recurring_event_data.weekly input').val();            // is 'n' for every_n_weeks field was typed ?
      values = parseInt(every_n_weeks);
      if (isNaN(values)) {
        return false;                                                 // if 'n' not a number, e.g. n = '', then stop checking further fields
      } else {
        recurenceObject.howOften = values;
        var selectedWeekDays = this.getFormField('.recurring_event_data.weekly label.day-button-selected');
        if (!selectedWeekDays.length) {                                 // if length = 0 (no day of week was selected)
          return false;                                               // some fields are missing
        } else {
          for (i = 0; i < selectedWeekDays.length; i++) {
            recurenceObject.when[i] = selectedWeekDays[i].innerHTML;
          }
          break;
        }

        //break;
      }

    case 'monthly':                                                   // check the presence of the MONTHLY recurence pattern fields
      var every_month_by_day_of_the_week = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month_by_day_of_the_week')[0].checked;
      var every_n_months_input = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count');
      var every_n_months_value = parseInt(every_n_months_input.val());
      var selectedCheckedButton = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day')[0].checked;

      var selectedMonthDays = this.getFormField('.recurring_event_data.monthly label.day-button-selected');

      // Is e.g. every_first_sunday button checked and every_n_month field not empty
      // and day_of_month button checked ?
      if ((every_month_by_day_of_the_week == false && isNaN(every_n_months_value)) ||
        (selectedCheckedButton == false && isNaN(every_n_months_value)) ||
        (selectedCheckedButton == false && selectedMonthDays.length == 0 && isNaN(every_n_months_value))) {
        return false;
      }

      recurenceObject.howOften = every_n_months_value;
      if ((isNaN(every_n_months_value) || every_n_months_input.val() <= 0)) {
        this.getFormField('.recurring_event_data.monthly').addClass('input_warning');
        this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count').val('');
      } else if (every_month_by_day_of_the_week) {
        this.getFormField('.recurring_event_data.monthly').removeClass('input_warning');
        recurenceObject.howOften = every_n_months_value;
        var cycle = this.getFormField('.recurring_event_data.monthly select#resource_planner_event_bymonthday').val();
        var whichDay = this.getFormField('.recurring_event_data.monthly select#resource_planner_event_bymonthday_day').val();
        recurenceObject.when[0] = cycle;
        recurenceObject.when[1] = whichDay;
        //break;
      } else {
        if (!selectedCheckedButton) {                           // if length = 0 (no day of week was selected)
          return false;                                         // some fields are missing
        } else {
          selectedMonthDays = this.getFormField('.recurring_event_data.monthly label.day-button-selected');
          if (!selectedMonthDays.length) {                     // if length !== 0 (day of week was selected)
            return false;                                      // some fields are missing
          } else {
            for (i = 0; i < selectedMonthDays.length; i++) {
              recurenceObject.when[i] = selectedMonthDays[i].innerHTML;
            }
            break;
          }
        }
      }
  }

  // single event
  if (recurencePattern == 'no_repeat') {
    this.prepareEvents(recurenceObject, recurencePattern);
    return true;
  }

  // checking the presence of the range_of_recurence fields section
  var selectedButton = this.getFormField('#resource_planner_event_until_no_end_date');
  if (selectedButton[0].checked) {
    // all required fields are present

    //startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
    //var datum = moment(moment.tz(start_date, startTimeZone)).format();
    var datum = moment(start_date).add(this._noEndDateDuration, 'months');
    recurenceObject.endDate = new Date(datum);
    this.prepareEvents(recurenceObject, recurencePattern);
    return true;
  }

  // is create_n_events button checked ?
  selectedButton = this.getFormField('#resource_planner_event_until_create_n_events');
  if (selectedButton[0].checked) {
    // YES, create_n_events button was checked
    this.getFormField('#resource_planner_event_until_repeat_until_date').val('');
    var create_n_events = this.getFormField('#resource_planner_event_until_count').val();

    // check presence of 'n' events number
    values = parseInt(create_n_events);

    // is 'n' number of events present ?
    if (isNaN(values)) {
      // NO, number of 'n' is not present, stop checking
      return false;
    } else {
      // all required fields are present
      recurenceObject.nrOfEvents = values;
      this.prepareEvents(recurenceObject, recurencePattern);
      return true;
    }
  }

  selectedButton = this.getFormField('#resource_planner_event_until_repeat_until');
  // is repeat button until checked ?
  if (selectedButton[0].checked) {
    // Yes, check presence of the until date
    var untilDate = this.getFormField('#resource_planner_event_until_repeat_until_date');
    //untilDate = dateAdd(untilDate, duration, durationUnits);
    var validDate = Date.parse(untilDate[0].value);
    if (validDate) {
      var extractedTime = moment(recurenceObject.endDate).format("HH:mm");
      extractedTime = untilDate[0].value + " " + extractedTime;
      recurenceObject.endDate = moment(moment.tz(extractedTime, endTimeZone)).format();
      if (recurenceObject.endDate < recurenceObject.startDate) {
        untilDate[0].value = '';
        this.getFormField('.range_of_recurence').addClass('input_warning');
        return false;
      } else {
        // all required fields are present
        //recurenceObject.endDate = untilDate[0].value;
        this.prepareEvents(recurenceObject, recurencePattern);
        return true;
      }
    } else {
      // some fields are missing
      return false;
    }
  } else {
    // some fields are missing
    return false;
  }
}
// end function recurenceInputStatus

//=============================================================================

FullcalendarTimeline.prototype.renderDurationField = function () {
  var eventDurationHours = this.getEventDurationHours();
  var durationUnits = this._formData.duration_units;

  var duration;
  switch (durationUnits) {
    case 'day':
    case 'days':
      duration = (eventDurationHours / 24);
      //duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
    case 'hours':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
    case 'minutes':
      duration = Math.round(eventDurationHours * 60);
      break;
    case 'second':
    case 'seconds':
      duration = Math.round(eventDurationHours * 60 * 60);
      break;
    default:
      duration = 9999;
      break;
  }

  this.getFormField(formField().DURATION).val(duration);
  // TODO: Is this line required
  // this.getFormField('#resource_planner_event_duration').val(duration);
  // TODO: Is this line required
} // End of renderDurationField

//=============================================================================
FullcalendarTimeline.prototype.renderDuration = function (eventDurationHours) {
  var durationUnits = this._formData.duration_units;

  var duration;
  switch (durationUnits) {
    case 'week':
    case 'weeks':
      duration = (eventDurationHours / (24 * 7)).toFixed(2);
      break;
    case 'day':
    case 'days':
      duration = (eventDurationHours / 24);
      //duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
    case 'hours':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
    case 'minutes':
      duration = Math.round(eventDurationHours * 60);
      break;
    case 'second':
    case 'seconds':
      duration = Math.round(eventDurationHours * 60 * 60);
      break;
    default:
      duration = 9999;
      break;
  }

  this.getFormField(formField().DURATION).val(duration);
  // TODO: Is this line required
  // this.getFormField("#resource_planner_event_duration").val(duration);
  // TODO: Is this line required

  return duration;
} // End of renderDuration

//=============================================================================
// Function to prepare events for rendering
//=============================================================================
FullcalendarTimeline.prototype.prepareEvents = function (recurenceObject, recurencePattern) {
  // 11.08.2020 var end_date;
  var start_date;
  var selectedWeekDayNumber;
  var startWeekDayNumber;
  var i;
  var j;
  var now;
  var end;
  var eventsArray = [];
  var nrOfOccurences;
  var found = false;

  var viewStartDate = new Date(recurenceObject.startDate);
  var viewEndDate = new Date(recurenceObject.endDate);

  // SWITCH FOR SINGLE EVENT, DAILY, WEEKLY or MONTHLY
  switch (recurencePattern) {

    //               ***** SINGLE EVENT *****
    case 'no_repeat':

      this.timeZoneConverter();
      eventsArray.push({});
      eventsArray[0].startDate = this._formData.start_date_with_timezone;
      eventsArray[0].endDate = this._formData.end_date_with_timezone;
      eventsArray[0].eventDuration = this._formData.duration;
      eventsArray[0].durationUnits = this._formData.duration_units;

      for (i = 0; i < eventsArray.length; i++) {
        eventsArray[i].startDate = this._formData.start_date_with_timezone;
        eventsArray[i].endDate = this._formData.end_date_with_timezone;
        eventsArray[i].initialStartDate = eventsArray[i].startDate;
        eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
        eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
        eventsArray[i].isDirty = false;
      }

      this._eventsArray = eventsArray;
      this._startingDate = new Date(recurenceObject.startDate);
      this._endingDate = new Date(recurenceObject.endDate);
      this._flag = true;
      this._zoomed = true;

      this.updateTimelineDuration(this._startingDate, this._endingDate);

      break;

    //               ***** DAILY *****
    case 'daily':
      if (recurenceObject.nrOfEvents) {
        // number of selected days is greater than number of events
        for (i = 0; i < recurenceObject.nrOfEvents; i++) {
          eventsArray.push({});
        }

        moment.tz.setDefault(this._formData.resource_planner_event_dtstart_timezone);
        for (i = 0; i < recurenceObject.nrOfEvents; i++) {
          if (i == 0) {
            start_date = this._formData.start_date_with_timezone;
            start_date = getDailyEventStartDate(start_date, recurenceObject);
            eventsArray[i].startDate = start_date;
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
          } else {
            start_date = moment(start_date).add(recurenceObject.howOften, 'days');
            start_date = getDailyEventStartDate(moment(start_date).format(), recurenceObject);
            eventsArray[i].startDate = start_date;
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
          }
        }

      } else {
        now = new Date(recurenceObject.startDate);
        end = new Date(recurenceObject.endDate);

        if (recurenceObject.everyWeekDayChecked) {
          nrOfOccurences = getNumberOfWeekDaysNoWeekends(now, end, recurenceObject.howOften);
        } else {
          nrOfOccurences = Math.ceil((moment(end).diff(now, 'days') + 2) / recurenceObject.howOften);
        }

        for (i = 0; i < nrOfOccurences; i++) {                // number of selected days is greater than number of events
          eventsArray.push({});
        }

        moment.tz.setDefault(this._formData.resource_planner_event_dtstart_timezone);
        for (i = 0; i < (nrOfOccurences); i++) {
          if (i == 0) {
            start_date = this._formData.start_date_with_timezone;
            start_date = getDailyEventStartDate(start_date, recurenceObject);
            eventsArray[i].startDate = start_date;
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
          } else {
            start_date = moment(start_date).add(recurenceObject.howOften, 'days');
            start_date = getDailyEventStartDate(moment(start_date).format(), recurenceObject);
            eventsArray[i].startDate = moment(start_date).format();
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
          }
        }
      }
      //Intl.DateTimeFormat().resolvedOptions().timeZone
      var endTimeZone = this._formData.resource_planner_event_dtend_timezone;
      var startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
      for (i = 0; i < eventsArray.length; i++) {
        var endDate = moment(dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits)).format();
        eventsArray[i].endDate = moment(moment.tz(endDate, endTimeZone)).format();
        var startDate = moment(moment.tz(startDate, startTimeZone)).format();
        eventsArray[i].initialStartDate = moment(moment.tz(startDate, startTimeZone)).format();
        eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
        eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
        eventsArray[i].isDirty = false;
      }

      viewStartDate = new Date(eventsArray[0].startDate);
      viewEndDate = new Date(eventsArray[eventsArray.length - 1].endDate);
      //viewEndDate = new Date(moment(eventsArray[eventsArray.length - 1].endDate).add(1, 'days'));

      this._eventsArray = eventsArray;
      this._startingDate = viewStartDate;
      this._endingDate = viewEndDate;
      this._flag = true;
      this._zoomed = false;

      this.updateTimelineDuration(this._startingDate, this._endingDate);

      break;

    //               ***** WEEKLY *****
    case 'weekly':
      var weekDaysNumberArray = [];
      var selectedDayOfWeekNumber;
      var numberOfDays;
      startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
      moment.tz.setDefault(startTimeZone);
      start_date = moment(this._formData.start_date).format();
      var StartDayOfWeek = start_date;
      var StartDayOfWeekNumber = moment(StartDayOfWeek).day();

      for (i = 0; i < recurenceObject.when.length; i++) {     // create a new array to hold week days number
        weekDaysNumberArray.push({});
      }

      for (i = 0; i < recurenceObject.when.length; i++) {     // update the array with the selectedweekdays to hold day numbers
        selectedDayOfWeekNumber = moment().day(recurenceObject.when[i]);
        weekDaysNumberArray[i] = selectedDayOfWeekNumber.day();
      }

      for (i = 0; i < weekDaysNumberArray.length; i++) {      // find the start day dependent on the startDate (selected in the menu)
        if (StartDayOfWeekNumber <= weekDaysNumberArray[i]) {
          numberOfDays = weekDaysNumberArray[i] - StartDayOfWeekNumber;
          start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
          var index = i;                                      // index of the found next day...
          found = true;
          break;
        }
      }

      if (!found) {
        for (i = 0; i < weekDaysNumberArray.length; i++) {
          if (StartDayOfWeekNumber >= weekDaysNumberArray[i]) {
            numberOfDays = (7 - StartDayOfWeekNumber) + weekDaysNumberArray[i];
            start_date = moment(moment(start_date).add(numberOfDays, 'days'));
            break;
          }
        }
      }

      var partOfArray = [];
      if (found) {
        partOfArray = weekDaysNumberArray.slice(index);
        for (i = 0; i < partOfArray.length; i++) {
          weekDaysNumberArray.pop();
        }
        weekDaysNumberArray = partOfArray.concat(weekDaysNumberArray);
      }

      if (recurenceObject.nrOfEvents == '') {
        var totalDayOfAppearance = 0;
        var dayNumberOfAppearances = 0;

        var begin_date = moment(start_date).format();
        for (i = 0; i < weekDaysNumberArray.length; i++) {
          dayNumberOfAppearances = this.countSelectedWeekdayAppearance(begin_date, recurenceObject.endDate, weekDaysNumberArray[i]);
          begin_date = moment(begin_date).add(1, 'days');
          dayNumberOfAppearances = Math.ceil(dayNumberOfAppearances / recurenceObject.howOften);
          totalDayOfAppearance = totalDayOfAppearance + dayNumberOfAppearances;
          dayNumberOfAppearances = 0;
        }

        for (i = 0; i < totalDayOfAppearance; i++) {              // number of selected days is greater than number of events
          eventsArray.push({});
        }
      } else {
        for (i = 0; i < recurenceObject.nrOfEvents; i++) {        // number of selected days is greater than number of events
          eventsArray.push({});
        }
      }

      if (recurenceObject.nrOfEvents) {    // Number of events greater than zero                                                          // number of events is selected

        for (i = 0; i < recurenceObject.nrOfEvents; i++) {
          startWeekDayNumber = moment(start_date).day();         // get the weekday number of the start date, e.g. sunday=0, monday=1,... here we get the startDate day number
          index = i % weekDaysNumberArray.length;

          if (index == 0 && i != 0) {
            numberOfDays = 7 * recurenceObject.howOften;
            start_date = moment(start_date).add(numberOfDays, 'days');
          }

          eventsArray[i].startDate = this.getWeeklyEventStartDate(weekDaysNumberArray[index], startWeekDayNumber, start_date);
          eventsArray[i].eventDuration = recurenceObject.eventDuration;
          eventsArray[i].durationUnits = recurenceObject.durationUnits;
        }

        endTimeZone = this._formData.resource_planner_event_dtend_timezone;
        for (i = 0; i < eventsArray.length; i++) {
          endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
          eventsArray[i].endDate = moment(moment.tz(endDate, endTimeZone)).format();
          startDate = eventsArray[i].startDate;
          eventsArray[i].initialStartDate = moment.tz(startDate, startTimeZone);
          eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
          eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
          eventsArray[i].isDirty = false;
        }

        viewStartDate = new Date(eventsArray[0].startDate);
        viewEndDate = new Date(eventsArray[eventsArray.length - 1].endDate);

        this._eventsArray = eventsArray;
        this._startingDate = viewStartDate;
        this._endingDate = viewEndDate;
        this._flag = true;
        this._zoomed = false;

        this.updateTimelineDuration(viewStartDate, viewEndDate);

        break;

      } else {
        var arrayStart = 0;
        var count = 0;
        begin_date = moment(start_date).format();
        for (i = 0; i < weekDaysNumberArray.length; i++) {
          startWeekDayNumber = moment(begin_date).day();
          selectedWeekDayNumber = moment().day(weekDaysNumberArray[i]);     // get the weekday name from the array (e.g. 'Monday', 'Thursday',...)
          selectedWeekDayNumber = selectedWeekDayNumber.day();
          dayNumberOfAppearances = this.countSelectedWeekdayAppearance(begin_date, recurenceObject.endDate, weekDaysNumberArray[i]);
          startDate = this.getWeeklyEventStartDate(selectedWeekDayNumber, startWeekDayNumber, begin_date);
          begin_date = moment(begin_date).add(1, 'days');

          count = count + Math.ceil(dayNumberOfAppearances / recurenceObject.howOften);
          for (j = arrayStart; j < count; j++) {
            eventsArray[j].startDate = moment(startDate).format();
            eventsArray[j].eventDuration = recurenceObject.eventDuration;
            eventsArray[j].durationUnits = recurenceObject.durationUnits;
            startDate = moment(startDate).add((recurenceObject.howOften * 7), 'days');
          }
          arrayStart = j;
        }

        eventsArray.sort(sortArray);
      }

      if (moment(recurenceObject.endDate).format() >= moment(start_date).format()) {
        endTimeZone = this._formData.resource_planner_event_dtend_timezone;
        for (i = 0; i < eventsArray.length; i++) {
          endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
          eventsArray[i].endDate = moment(moment.tz(endDate, endTimeZone)).format();
          startDate = eventsArray[i].startDate;
          eventsArray[i].initialStartDate = moment.tz(startDate, startTimeZone);
          eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
          eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
          eventsArray[i].isDirty = false;
        }

        if (moment(eventsArray[i - 1].endDate).format("YYYY-MM-DD") > moment(recurenceObject.endDate).format("YYYY-MM-DD")) {
          eventsArray.pop();
        }

        viewStartDate = new Date(eventsArray[0].startDate);
        viewEndDate = new Date(eventsArray[eventsArray.length - 1].endDate);

        this._eventsArray = eventsArray;
        this._startingDate = viewStartDate;
        this._endingDate = viewEndDate;
        this._flag = true;
        this._zoomed = false;

        this.updateTimelineDuration(this._startingDate, this._endingDate);
        //renderEvents(eventsArray, viewStartDate, viewEndDate);
      } else {
        untilDate = this.getFormField('#resource_planner_event_until_repeat_until_date.form-control.date-field.datepick')[0];
        untilDate.value = '';
        this.getFormField('.range_of_recurence').addClass('input_warning');
      }

      break;

    //              ***** MONTHLY *****
    case 'monthly':
      var order;
      startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
      endTimeZone = this._formData.resource_planner_event_dtend_timezone;
      var partOfDate = this.prepareTimeAndTimeZone();

      //=============================================================================
      if (isNaN(recurenceObject.when[0])) {      // 'recurence_pattern' selected is e.g. 'Every', 'The first', 'The second',... was selected

        var selectedDayWeekDate = moment().day(recurenceObject.when[1]);
        var startDateOfMonth = moment(this._formData.start_date_with_timezone).startOf('month');
        order = getOrder(recurenceObject);

        //=============================================================================
        if (recurenceObject.nrOfEvents) {                              // 'create X events' of range_of_recurence was selected (for NaN)

          partOfDate = this.prepareTimeAndTimeZone();
          for (i = 0; i < recurenceObject.nrOfEvents; i++) {           // number of selected days is greater than number of events
            eventsArray.push({});
          }

          if (order < 5) {                                             // one of 'every', 'first', 'second', 'third', 'fourth' was selected
            start_date = this.getStartDateForSelectedWeekday(recurenceObject, this._formData.start_date_with_timezone);
            start_date = moment(start_date).format();
            var start_month = moment(start_date).month();

            for (i = 0; i < recurenceObject.nrOfEvents; i++) {          // get all events for the selected day of the week
              start_date = moment(start_date).format();
              if (start_month == moment(start_date).month()) {
                var newDate = moment(start_date).format("YYYY-MM-DD") + partOfDate;
                eventsArray[i].startDate = moment(newDate).format();
                eventsArray[i].eventDuration = recurenceObject.eventDuration;
                eventsArray[i].durationUnits = recurenceObject.durationUnits;
                if (order == 0) {
                  start_date = moment(start_date).add(1, 'weeks');
                } else {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                  startDateOfMonth = moment(start_date).startOf('month');
                  if (i == 0) {
                    start_date = getTheNextEventDate(eventsArray[i].startDate, order, recurenceObject);
                  } else {
                    start_date = getTheNextEventDate(eventsArray[i - 1].startDate, order, recurenceObject);
                  }
                }

              } else {
                start_date = moment(eventsArray[i - 1].startDate).add(recurenceObject.howOften, 'months');
                startDateOfMonth = moment(start_date).startOf('month');
                if (i == 0) {
                  start_date = getTheNextEventDate(eventsArray[i].startDate, order, recurenceObject);
                } else {
                  start_date = getTheNextEventDate(eventsArray[i - 1].startDate, order, recurenceObject);
                }
                newDate = moment(start_date).format("YYYY-MM-DD") + partOfDate;
                eventsArray[i].startDate = moment(newDate).format();
                eventsArray[i].eventDuration = recurenceObject.eventDuration;
                eventsArray[i].durationUnits = recurenceObject.durationUnits;
                start_date = new Date(start_date);
                start_month = start_date.getMonth();

                if (order == 0) {
                  start_date = moment(start_date).add(1, 'weeks');
                } else {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                }
              }
            }                                             // End of - get all events for the selected day of the week
          }                                               // End of - one of 'every', 'first', 'second', 'third', 'fourth' was selected

          if (order >= 5) {                               // Either 'fifth' or 'last' were selected
            selectedDayWeekDate = moment().day(recurenceObject.when[1]);
            var selectedDayNumber = moment(selectedDayWeekDate).day();
            if (order == 5) {                             // Option 'fifth' was selected
              var valid = true;
              for (i = 0; i < recurenceObject.nrOfEvents; i++) {
                valid = true;
                while (valid) {
                  start_date = moment(startDateOfMonth).format();
                  var startYear = moment(start_date).year();
                  var startMonth = moment(start_date).month();
                  var numberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();
                  if (numberOfDaysInMonth > 28) {
                    for (j = 29; j <= numberOfDaysInMonth; j++) {
                      startDateOfMonth = moment([startYear, startMonth, j]);
                      startDateOfMonth = new Date(startDateOfMonth);
                      var startingDate = new Date(recurenceObject.startDate);
                      var startDateNumber = moment(startDateOfMonth).day();
                      if ((startDateNumber == selectedDayNumber) && (moment(startDateOfMonth) >= moment(startingDate))) {
                        newDate = moment(startDateOfMonth).format("YYYY-MM-DD") + partOfDate;
                        eventsArray[i].startDate = moment(newDate).format();
                        eventsArray[i].eventDuration = recurenceObject.eventDuration;
                        eventsArray[i].durationUnits = recurenceObject.durationUnits;
                        valid = false;
                      }
                    }
                  }
                  startDateOfMonth = moment(startDateOfMonth).startOf('month');
                  startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
                }
              }
            }                                       // End of - Option 'fifth' was selected

            if (order == 6) {
              // Start of selected 'last'
              start_date = new Date(startDateOfMonth);
              numberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();


              selectedDayWeekDate = moment().day(recurenceObject.when[1]);
              selectedDayNumber = moment(selectedDayWeekDate).day();

              i = 0;
              while (i < recurenceObject.nrOfEvents) {     // Begin of WHILE
                moment(startDateOfMonth).format();
                start_date = moment(startDateOfMonth).format();
                startYear = moment(start_date).year();
                startMonth = moment(start_date).month();
                numberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();
                for (j = numberOfDaysInMonth; j >= 20; j--) {
                  startDateOfMonth = moment([startYear, startMonth, j]);
                  startDateOfMonth = new Date(startDateOfMonth);
                  startingDate = new Date(recurenceObject.startDate);
                  startDateNumber = moment(startDateOfMonth).day();
                  if ((startDateNumber == selectedDayNumber) && (moment(startDateOfMonth) >= moment(startingDate))) {
                    newDate = moment(startDateOfMonth).format("YYYY-MM-DD") + partOfDate;
                    eventsArray[i].startDate = moment(newDate).format();
                    eventsArray[i].eventDuration = recurenceObject.eventDuration;
                    eventsArray[i].durationUnits = recurenceObject.durationUnits;
                    i++;
                    break;
                  }
                }

                startDateOfMonth = moment(startDateOfMonth).startOf('month');
                startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
              }                                                               // End of WHILE
            }                                                                 // End of selected 'last'
          }                                       // End of - Either 'fifth' or 'last' were selected
          //}

          endTimeZone = this._formData.resource_planner_event_dtend_timezone;
          moment.tz.setDefault(endTimeZone);
          for (i = 0; i < eventsArray.length; i++) {
            eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
            eventsArray[i].endDate = moment(eventsArray[i].endDate).format();
            eventsArray[i].initialStartDate = eventsArray[i].startDate;
            eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
            eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
            eventsArray[i].isDirty = false;
          }

          viewStartDate = new Date(eventsArray[0].startDate);
          viewEndDate = new Date(eventsArray[eventsArray.length - 1].endDate);

          this._eventsArray = eventsArray;
          this._startingDate = new Date(viewStartDate);
          this._endingDate = new Date(viewEndDate);
          this._flag = true;
          this._zoomed = false;

          this.updateTimelineDuration(this._startingDate, this._endingDate);
          //renderEvents(eventsArray, viewStartDate, viewEndDate);
        }                                                       // End of - 'create X events' of range_of_recurence was selected (for NaN)

        //=============================================================================
        if (recurenceObject.nrOfEvents == '') {                  // A 'Repeat until' or 'no_end_date' has bin selected (for NaN)

          startingDate = this._formData.start_date_with_timezone;
          partOfDate = this.prepareTimeAndTimeZone();

          if (order < 5) {     // Hash (0 to 6) - ['every', 'first', 'second', 'third', 'fourth', 'fifth', 'last']
            start_date = this.getStartDateForSelectedWeekday(recurenceObject, this._formData.start_date_with_timezone);
            if (start_date == false) {
              start_date = moment(recurenceObject.startDate).format();
            }
            start_month = new Date(start_date).getMonth();
            index = 0;

            while (moment(start_date).format("YYYY-MM-DD") <= moment(viewEndDate).format("YYYY-MM-DD")) {
              if (start_month == moment(start_date).month()) {
                eventsArray.push({});
                newDate = moment(start_date).format("YYYY-MM-DD") + partOfDate;
                eventsArray[index].startDate = moment(newDate).format();
                eventsArray[index].eventDuration = recurenceObject.eventDuration;
                eventsArray[index].durationUnits = recurenceObject.durationUnits;
                index++;
                if (order == 0) {
                  var testDate = start_date;
                  start_date = moment(start_date).add(1, 'weeks');
                  if (start_date > moment(testDate).endOf('month')) {
                    var lastMonth = moment(testDate).month();
                    start_date = moment(start_date).add(4 * (recurenceObject.howOften - 1), 'weeks');
                    if ((moment(start_date).month() - lastMonth) < recurenceObject.howOften) {
                      start_date = moment(start_date).add(1, 'weeks');
                    }
                  }
                } else {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                  start_date = moment(start_date).startOf('month'); // set start of month
                  start_month = moment(start_date).month();
                  start_date = this.getStartDateForSelectedWeekday(recurenceObject, start_date);
                }
              } else {
                start_month = moment(start_date).month();
              }
            }
          }



          if (order >= 5) {                                                // Selected order is either 'fifth' or 'last'
            selectedDayWeekDate = moment().day(recurenceObject.when[1]);
            selectedDayNumber = moment(selectedDayWeekDate).day();

            if (order == 5) {                                              // Begin of selected 'fifth'
              i = 0;
              while (moment(startDateOfMonth).format("YYYY-MM-DD") < moment(recurenceObject.endDate).format("YYYY-MM-DD")) {
                start_date = startDateOfMonth.calendar();
                startYear = startDateOfMonth.year();
                startMonth = startDateOfMonth.month();
                numberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();

                startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
                moment.tz.setDefault(startTimeZone);

                if (numberOfDaysInMonth > 28) {
                  for (j = 29; j <= numberOfDaysInMonth; j++) {
                    moment.tz.setDefault(startTimeZone);
                    startDateOfMonth = moment([startYear, startMonth, j]).format();
                    startDateOfMonth = new Date(startDateOfMonth);
                    startDateNumber = moment(startDateOfMonth).day();
                    if ((startDateNumber == selectedDayNumber) && (new Date(startDateOfMonth).yyyymmdd() >= new Date(startingDate).yyyymmdd())) {
                      eventsArray.push({});
                      newDate = moment(startDateOfMonth).format("YYYY-MM-DD") + partOfDate;
                      eventsArray[i].startDate = moment(newDate).format();
                      eventsArray[i].eventDuration = recurenceObject.eventDuration;
                      eventsArray[i].durationUnits = recurenceObject.durationUnits;
                      i++;
                    }
                  }
                }

                startDateOfMonth = moment(startDateOfMonth).startOf('month');
                startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
              }
            }                                                                  // End of selected 'fifth'

            if (order == 6) {                                                  // Start of selected 'last'
              selectedDayWeekDate = moment().day(recurenceObject.when[1]);
              selectedDayNumber = moment(selectedDayWeekDate).day();
              startDateOfMonth = moment(this._formData.start_date_with_timezone).format("YYYY-MM-DD");
              i = 0;
              while (moment(startDateOfMonth) <= moment(recurenceObject.endDate)) {  // Begin of WHILE
                //start_date = startDateOfMonth.calendar();
                startYear = moment(startDateOfMonth).year();
                startMonth = moment(startDateOfMonth).month();
                numberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();
                startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
                moment.tz.setDefault(startTimeZone);
                for (j = numberOfDaysInMonth; j >= 20; j--) {
                  startDateOfMonth = moment([startYear, startMonth, j]).format();
                  startDateNumber = moment(startDateOfMonth).day();
                  if ((startDateNumber == selectedDayNumber) && (new Date(startDateOfMonth).yyyymmdd() >= new Date(startingDate).yyyymmdd())) {
                    eventsArray.push({});
                    newDate = moment(startDateOfMonth).format("YYYY-MM-DD") + partOfDate;
                    eventsArray[i].startDate = moment(newDate).format();
                    eventsArray[i].eventDuration = recurenceObject.eventDuration;
                    eventsArray[i].durationUnits = recurenceObject.durationUnits;
                    i++;
                    break;
                  }
                }

                startDateOfMonth = moment(startDateOfMonth).startOf('month');
                startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
              }    // End of WHILE
            }     // End of selected 'last'
          }      // End of - Selected order is either 'fifth' or 'last'


          if (eventsArray.length > 0) {
            for (i = 0; i < eventsArray.length; i++) {
              endDate = moment(dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits)).format();
              eventsArray[i].endDate = moment(moment.tz(endDate, endTimeZone)).format();
              eventsArray[i].startDate = moment(eventsArray[i].startDate).format();
              eventsArray[i].initialStartDate = moment(eventsArray[i].startDate).format();
              eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
              eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
              eventsArray[i].isDirty = false;
            }

            viewStartDate = new Date(eventsArray[0].startDate);
            viewEndDate = new Date(eventsArray[eventsArray.length - 1].endDate);

            this._eventsArray = eventsArray;
            this._startingDate = new Date(viewStartDate);
            this._endingDate = new Date(viewEndDate);
            this._flag = true;
            this._zoomed = false;

            this.updateTimelineDuration(this._startingDate, this._endingDate);
            //renderEvents(eventsArray, viewStartDate, viewEndDate);

          } else {
            var untilDate = this.getFormField('#resource_planner_event_until_repeat_until_date.form-control.date-field.datepick');
            untilDate[0].value = '';
            this.getFormField('.range_of_recurence').addClass('input_warning');
          }    // End of - A 'Repeat until' or 'no_end_date' has bin selected (for NaN)
        }
      }       // End of - 'recurence_pattern' seelcted is e.g. 'Every', 'The first', 'The second',... was selected

      //=============================================================================
      if (!(isNaN(recurenceObject.when[0]))) {        // 'recurence_pattern' seelcted is e.g. 01, 02, 29,...,31

        if (recurenceObject.nrOfEvents) {             // 'create X events' of range_of_recurence was selected (for !isNaN)
          var arrayOfDays = [];

          for (i = 0; i < recurenceObject.nrOfEvents; i++) {    // number of selected days is greater than number of events
            eventsArray.push({});
          }

          for (i = 0; i < recurenceObject.when.length; i++) {
            arrayOfDays.push({});
            arrayOfDays[i] = recurenceObject.when[i];
          }

          var minutes = moment(recurenceObject.startDate).format("HH:mm");
          start_date = recurenceObject.startDate;
          begin_date = new Date(start_date);
          var start_year = begin_date.getFullYear();
          start_month = begin_date.getMonth();
          startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
          var modulu = 0;
          var flag;

          for (i = 0; i < eventsArray.length; i++) {
            flag = true;
            while (flag) {
              index = modulu % recurenceObject.when.length;
              if (dateIsValid(arrayOfDays[index], start_month, start_year)) {
                if (moment(moment([start_year, start_month, arrayOfDays[index]])).format("YYYY-MM-DD")
                  >= moment(begin_date).format("YYYY-MM-DD")) {
                  start_date = moment([start_year, start_month, arrayOfDays[index]]);
                  start_date = start_date.format("YYYY-MM-DD") + " " + minutes;
                  start_date = moment.tz(start_date, startTimeZone);
                  eventsArray[i].startDate = moment(start_date).format();
                  eventsArray[i].startDate = moment(start_date).format();
                  eventsArray[i].eventDuration = recurenceObject.eventDuration;
                  eventsArray[i].durationUnits = recurenceObject.durationUnits;
                  modulu++;
                  flag = false;
                  if ((index + 1) == recurenceObject.when.length) {
                    start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                    if (dateIsValid(arrayOfDays[index], start_month, start_year)) {
                      start_year = new Date(start_date).getFullYear();
                      start_month = new Date(start_date).getMonth();
                      break;
                    } else {
                      modulu++;
                      flag = true;
                    }
                  }
                } else {
                  if ((index + 1) == recurenceObject.when.length) {
                    start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                    start_year = new Date(start_date).getFullYear();
                    start_month = new Date(start_date).getMonth();
                    modulu++;
                    flag = true;
                  } else {
                    modulu++;
                  }
                }

              } else {
                if ((index + 1) == recurenceObject.when.length) {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                  start_year = new Date(start_date).getFullYear();
                  start_month = new Date(start_date).getMonth();
                  modulu++;
                  flag = true;
                } else {
                  modulu++;
                }
              }
            }
          }

          for (i = 0; i < eventsArray.length; i++) {
            eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
            eventsArray[i].endDate = moment(eventsArray[i].endDate).format();
            eventsArray[i].initialStartDate = eventsArray[i].startDate;
            eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
            eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
            eventsArray[i].isDirty = false;
          }

          //eventsArray.sort(sortArray);

          viewStartDate = new Date(eventsArray[0].startDate);
          //viewStartDate = new Date(moment(eventsArray[0].startDate).format());
          viewEndDate = new Date(eventsArray[i - 1].endDate);

          this._eventsArray = eventsArray;
          this._startingDate = viewStartDate;
          this._endingDate = viewEndDate;
          this._flag = true;
          this._zoomed = false;

          this.updateTimelineDuration(this._startingDate, this._endingDate);
          //renderEvents(eventsArray, viewStartDate, viewEndDate);
        }


        // End of - 'create X events' of range_of_recurence was selected (for !isNaN)

        if (recurenceObject.nrOfEvents == '') {          // A 'Repeat until' or 'no_end_date' has bin selected (for !isNaN)

          start_date = this.getStartDateForSelectedWeekday(recurenceObject, this._formData.start_date_with_timezone);
          start_date = new Date(start_date);
          selectedDayNumber = moment(start_date).day();
          index = 0;

          arrayOfDays = [];

          for (i = 0; i < recurenceObject.when.length; i++) {   // find the start day dependent on the startDate (selected in the menu)
            if (moment(recurenceObject.startDate).date() <= recurenceObject.when[i]) {
              numberOfDays = recurenceObject.when[i] - moment(recurenceObject.startDate).date();
              start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
              index = i;         // index of the found next day...
              found = true;
              break;
            }
          }

          if (!found) {
            numberOfDaysInMonth = moment(recurenceObject.startDate).daysInMonth();
            numberOfDays = (numberOfDaysInMonth - recurenceObject.when[1]) + 1;
            start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');

            for (i = 0; i < recurenceObject.when.length; i++) {
              arrayOfDays.push({});
              arrayOfDays[i] = recurenceObject.when[i];
            }
          }

          if (found) {
            for (i = 0; i < recurenceObject.when.length; i++) {
              arrayOfDays.push({});
              arrayOfDays[i] = recurenceObject.when[i];
            }

            partOfArray = arrayOfDays.slice(index);
            for (j = 0; j < partOfArray.length; j++) {
              arrayOfDays.pop();
            }
            arrayOfDays = partOfArray.concat(arrayOfDays);
          }

          start_date = new Date(start_date);
          start_year = start_date.getFullYear();
          start_month = start_date.getMonth();
          var startMinutes = moment(start_date).format("HH:mm");

          index = 0;
          var start = 0;
          var eventArrayIndex = 0;

          viewEndDate = moment(recurenceObject.endDate);
          begin_date = new Date(recurenceObject.startDate);

          while (moment(start_date).format("YYYY-MM-DD") <= moment(viewEndDate).format("YYYY-MM-DD")) {
            var x = index % recurenceObject.when.length;
            if (x == 0 && index == 0) {
              start = new Date(begin_date);
              start_year = start.getFullYear();
              start_month = start.getMonth();

              if (dateIsValid(recurenceObject.when[x], start_month, start_year)) {
                start = moment([start_year, start_month, recurenceObject.when[x]]);
                start = moment(start).format("YYYY-MM-DD") + "T" + startMinutes;

                if (moment(start).format("YYYY-MM-DD") > moment(viewEndDate).format("YYYY-MM-DD")) {
                  break;
                }

                if (moment(start).format("YYYY-MM-DD") >= moment(begin_date).format("YYYY-MM-DD")) {
                  eventsArray.push({});
                  eventsArray[eventArrayIndex].startDate = moment(start).format();
                  eventsArray[eventArrayIndex].eventDuration = recurenceObject.eventDuration;
                  eventsArray[eventArrayIndex].durationUnits = recurenceObject.durationUnits;
                  start_date = moment(start);
                  eventArrayIndex++;
                } else {
                  start_date = moment(begin_date).format();
                }
              }
              start_date = moment(begin_date).format();
            }

            if (x == 0 && index !== 0) {
              start = moment(start_date).add(recurenceObject.howOften, 'months');
              start = new Date(start);
              start_year = start.getFullYear();
              start_month = start.getMonth();
              startMinutes = moment(start_date).format("HH:mm:ss");

              if (dateIsValid(recurenceObject.when[x], start_month, start_year)) {
                start = moment([start_year, start_month, recurenceObject.when[x]]);
                start = moment(start).format("YYYY-MM-DD") + "T" + startMinutes;

                if (moment(start).format("YYYY-MM-DD") > moment(viewEndDate).format("YYYY-MM-DD")) {
                  break;
                }

                if (moment(start).format("YYYY-MM-DD") >= moment(begin_date).format("YYYY-MM-DD")) {
                  eventsArray.push({});
                  eventsArray[eventArrayIndex].startDate = moment(start).format();
                  eventsArray[eventArrayIndex].eventDuration = recurenceObject.eventDuration;
                  eventsArray[eventArrayIndex].durationUnits = recurenceObject.durationUnits;
                  start_date = moment(start);
                  eventArrayIndex++;
                } else {
                  start_date = moment(start);
                }
              } else {
                start_date = moment(start);
              }
            } else {
              if (x !== 0) {
                if (recurenceObject.when[x] < recurenceObject.when[x - 1]) {
                  start_month = start_month + recurenceObject.howOften;
                }

                if (dateIsValid(recurenceObject.when[x], start_month, start_year)) {
                  start = moment([start_year, start_month, recurenceObject.when[x]]);
                  start = moment(start).format("YYYY-MM-DD") + "T" + startMinutes;
                  viewEndDate = moment(viewEndDate).format("YYYY-MM-DD") + "T" + startMinutes;
                  if (moment(start).format("YYYY-MM-DD") > moment(viewEndDate).format("YYYY-MM-DD")) {
                    break;
                  }

                  if (moment(start).format("YYYY-MM-DD") >= moment(begin_date).format("YYYY-MM-DD")) {
                    if (moment(start).format("YYYY-MM-DD") > moment(viewEndDate).format("YYYY-MM-DD")) {
                      break;
                    }
                    eventsArray.push({});
                    eventsArray[eventArrayIndex].startDate = moment(start).format();
                    eventsArray[eventArrayIndex].eventDuration = recurenceObject.eventDuration;
                    eventsArray[eventArrayIndex].durationUnits = recurenceObject.durationUnits;
                    eventArrayIndex++;
                    start_date = moment(start);
                  }
                }
              }
            }

            index++;
          }

          if (eventsArray.length > 0) {
            for (i = 0; i < eventsArray.length; i++) {
              eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
              eventsArray[i].endDate = moment(eventsArray[i].endDate).format();
              eventsArray[i].initialStartDate = eventsArray[i].startDate;
              eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
              eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
              eventsArray[i].isDirty = false;
            }

            viewStartDate = moment(eventsArray[0].startDate);
            viewEndDate = new Date(eventsArray[eventsArray.length - 1].endDate);
            //viewEndDate = moment(eventsArray[eventsArray.length - 1].startDate).add(eventsArray[eventsArray.length - 1].eventDuration, eventsArray[eventsArray.length - 1].durationUnits);

            this._eventsArray = eventsArray;
            this._startingDate = viewStartDate;
            this._endingDate = viewEndDate;
            this._flag = true;
            this._zoomed = false;

            this.updateTimelineDuration(viewStartDate, viewEndDate);
            //renderEvents(eventsArray, viewStartDate, viewEndDate);

          } else {
            untilDate = this.getFormField('#resource_planner_event_until_repeat_until_date.form-control.date-field.datepick');
            untilDate[0].value = '';
            this.getFormField('.range_of_recurence').addClass('input_warning');
          }
        } // A 'Repeat until' or 'no_end_date' has bin selected (for !isNaN)
      } // End of - 'recurence_pattern' seelcted is e.g. 01, 02, 29,...,31

  } // End of - SWITCH FOR SINGLE EVENT, DAILY, WEEKLY or MONTHLY

} // End of prepareEvents() - Function to prepare events for rendering

//=============================================================================
// Function to get the weekly start date for an event
//=============================================================================
FullcalendarTimeline.prototype.getWeeklyEventStartDate = function (selectedWeekDayNumber, startWeekDayNumber, startDate) {

  var nrOfDays;
  var start_date;

  selectedWeekDayNumber = moment().day(selectedWeekDayNumber);
  selectedWeekDayNumber = moment(selectedWeekDayNumber).day();  // get the weekday number of a selected weekday (e.g. Monday, Thursday,...)
  start_date = moment(startDate);                               // calculate the start_date for the weekday to start events
  nrOfDays = selectedWeekDayNumber - startWeekDayNumber;        // get the difference in days between the input startDate and the new weekday
  if (nrOfDays == 0) {
    start_date = moment(startDate);     // if '0' then it is the same day as the input startDate
  } else {
    if (nrOfDays > 0) {
      start_date = moment(start_date).add(nrOfDays, 'days');   // if event day is ahead from startDate, then add days to the input startDate
    } else {
      nrOfDays = (7 - startWeekDayNumber) + selectedWeekDayNumber;  // if input startDate is ahead
      start_date = moment(start_date).add(nrOfDays, 'days');        // add days to the selected weekday
    }
  }
  return start_date.format();
}

//=============================================================================
// Function to get the monthly start date for an event
//=============================================================================
FullcalendarTimeline.prototype.getMonthlyEventStartDate = function (selectedMonthDay, startDate) {
  startDate = new Date(startDate);

  var start_year = startDate.getFullYear();
  var start_month = startDate.getMonth();
  var day_of_month = startDate.getDate();
  if (day_of_month > selectedMonthDay) {
    var start_day = selectedMonthDay;
    var start_date = moment([start_year, start_month, start_day]);
    start_date = start_date.add(1, 'months');
  } else {
    start_day = selectedMonthDay;
    start_date = moment([start_year, start_month, start_day]);
  }
  return start_date.format();
}

//=============================================================================
// Count the times a selected week day appearce between start and end date
//=============================================================================
FullcalendarTimeline.prototype.countSelectedWeekdayAppearance = function (startdate, enddate, selectedDayOfWeekNumber) {   // How many times a selected weekday  = function (e.g. Monday) appears
  var endDate = moment(enddate);
  var startDate = moment(startdate);   // The start date is when the selected weekday appears for the first time

  if (moment(endDate).format("YYYY-MM-DD") < moment(startdate).format("YYYY-MM-DD")) {
    numberOfWeekDayInMonth = 0;
    return numberOfWeekDayInMonth;
  }

  var diffDays = endDate.diff(startDate, 'days') + 2;  // How many says between start and end date
  var nextDay = moment(startDate);
  var numberOfWeekDayInMonth = 0;

  for (var i = 0; i < diffDays; i++) {       // Loop to find the number of times the selected weekday appears
    if (nextDay.day() === selectedDayOfWeekNumber)    // Selected weekday found ?
    {
      numberOfWeekDayInMonth++;     // update counter
    }
    nextDay = nextDay.add(1, 'days');    // move to next day. Needed to know if the day is the one searched
  }
  return numberOfWeekDayInMonth;     // return counter
}

//=============================================================================
// Get the start date for a selected week day
//=============================================================================
FullcalendarTimeline.prototype.getStartDateForSelectedWeekday = function (recurenceObject, inputDate) {           // calculate the start date for the selected weekday
  moment.tz.setDefault(this._formData.resource_planner_event_dtstart_timezone);
  var start_date = inputDate;
  var selectedDayOfWeekNumber = moment().day(recurenceObject.when[1]);
  selectedDayOfWeekNumber = moment(selectedDayOfWeekNumber).day();

  var order = getOrder(recurenceObject);
  var notFound = true;

  if (order == 0) {
    var beginnDate = moment(start_date).startOf('month').format();
    while (notFound) {
      var dayNumber = moment(beginnDate).day();
      if (dayNumber == selectedDayOfWeekNumber) {
        if (moment(beginnDate).format("YYYY-MM-DD") < moment(start_date).format("YYYY-MM-DD")) {
          beginnDate = moment(beginnDate).add(recurenceObject.howOften, 'months');
        } else {
          if (recurenceObject.nrOfEvents) {
            return beginnDate;
          }
          if (moment(beginnDate).format("YYYY-MM-DD") > moment(recurenceObject.endDate).format("YYYY-MM-DD")) {
            return false;
          } else {
            return beginnDate;
          }
        }
      } else {
        beginnDate = moment(beginnDate).add(1, 'days');
      }
    }
    return false;
  }

  if (order > 0) {
    start_date = moment(start_date).startOf('month').format();
    start_date = moment(start_date).add((order - 1), 'weeks');
    beginnDate = start_date;
    while (notFound) {
      dayNumber = moment(beginnDate).day();
      if (dayNumber == selectedDayOfWeekNumber) {
        if (moment(beginnDate).format("YYYY-MM-DD") < moment(start_date).format("YYYY-MM-DD")) {
          beginnDate = moment(beginnDate).add(1, 'months');
        } else {
          return beginnDate;
        }
      } else {
        beginnDate = moment(beginnDate).add(1, 'days');
      }
    }
    return false;
  }
}

//=============================================================================
// Function to render events
//=============================================================================
FullcalendarTimeline.prototype.renderEvents = function (eventsArray, viewStartDate, viewEndDate) {     //Function is triggered by prepareEvents

  $('body').css({ 'cursor': 'wait' });

  // Remove existing 'highlighter' bars, before re-rendering
  if (this._timelineViewWrapper.find('.highlighter').length != 0) {
    this._timelineViewWrapper.find('.highlighter').remove();
  }

  this.tzOffset();

  var isRTL = (this._fullcalendarObject.getOption('dir') == 'rtl');
  var view = this._fullcalendarObject.view;

  viewStartDate = new Date(view.currentStart);
  viewEndDate = new Date(view.currentEnd);

  var viewStartTime = viewStartDate.getTime();
  var viewEndTime = viewEndDate.getTime();
  //var viewDuration = viewEndTime - viewStartTime;

  for (var i = 0; i < eventsArray.length; i++) {
    var duration = eventsArray[i].eventDuration;
    var durationUnits = eventsArray[i].durationUnits;

    this._timelineViewWrapper.find('tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<div id="highlighter-' + i + '" class="highlighter" draggable="true"></div>'));

    var startDate = new Date(eventsArray[i].startDate)
    var width;

    view = this._fullcalendarObject.view;
    viewStartDate = new Date(view.currentStart);
    viewEndDate = new Date(view.currentEnd);
    viewStartTime = viewStartDate.getTime();
    viewEndTime = viewEndDate.getTime();
    var viewDuration = viewEndTime - viewStartTime;
    width = this.setHighlighterBarWidth(duration, durationUnits)

    this._timelineViewWrapper.find('#highlighter-' + i).css('width', width);

    if (isRTL) {
      this._timelineViewWrapper.find('#highlighter-' + i).css('left', this.getEventWindowWidth() - ((((startDate.getTime() + this.tzOffset()) - viewStartTime) / viewDuration) * this.getEventWindowWidth()) - width);
    } else {
      this._timelineViewWrapper.find('#highlighter-' + i).css('left', (((startDate.getTime() - viewStartTime) / viewDuration) * this.getEventWindowWidth()));
      //this._timelineViewWrapper.find('#highlighter-' + i).css('left', (((startDate.getTime() + this.tzOffset()) - viewStartTime) / viewDuration) * this.getEventWindowWidth());
    }

  }

  // Mechanism to pass (this) to the handlers
  var fullCalendarTimelineObject = this;

  this._timelineViewWrapper.find('.highlighter').height(this.getEventWindowHeight());
  this._timelineViewWrapper.find('.highlighter').draggable({ axis: 'x' });
  this._timelineViewWrapper.find('.highlighter').resizable({ handles: 'e, w' });
  this._timelineViewWrapper.find('.highlighter').css('visibility', 'visible');
  this._timelineViewWrapper.find('.highlighter').css('background-color', this._applicationPreferences.getParameter('highlighter_bar_colour'));

  this._timelineViewWrapper.find('.highlighter').on('drag', function (event, ui) {
    fullCalendarTimelineObject.onHighlighterBarUpdate(event, ui, $(this));
    fullCalendarTimelineObject.renderSelectedResources();
    fullCalendarTimelineObject.showTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('resize', function (event, ui) {
    fullCalendarTimelineObject.onHighlighterBarUpdate(event, ui, $(this));
    fullCalendarTimelineObject.renderSelectedResources();
    fullCalendarTimelineObject.showTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('mouseup', function (event, ui) {
    // after drag/resize operation
    fullCalendarTimelineObject.updateEventUnitsFormFields();
  });

  this._timelineViewWrapper.find('.highlighter').on('mouseenter', function (event, ui) {
    fullCalendarTimelineObject.showTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('mouseleave', function (event, ui) {
    fullCalendarTimelineObject.hideTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('dblclick', function (event, ui) {
    fullCalendarTimelineObject.dblclickEventZoomIn(event, ui, $(this));
  });

  $('body').css({ 'cursor': 'auto' });

  // Update eventsArray session cookie
  this.updateEventUnitsFormFields();
}

FullcalendarTimeline.prototype.clearHighlighterConflicts = function () {
  if (typeof this._eventsArray !== 'undefined') {
    for (var eventArrayIndex = 0; eventArrayIndex < this._eventsArray.length; eventArrayIndex++) {
      this._eventsArray[eventArrayIndex].isInConflict = false;
    }
  }
}

FullcalendarTimeline.prototype.displayHighlighterConflicts = function () {
  if (typeof this._eventsArray !== 'undefined') {
    for (var eventArrayIndex = 0; eventArrayIndex < this._eventsArray.length; eventArrayIndex++) {
      var highlighter_color = (this._eventsArray[eventArrayIndex].isInConflict == true) ?
       this._applicationPreferences.getParameter('conflict_timeline_colour') :
        this._applicationPreferences.getParameter('highlighter_bar_colour');
      this._timelineViewWrapper.find('#highlighter-' + eventArrayIndex).css('background-color', highlighter_color);
    }
  }
}

//=============================================================================
// get a valid start date for a daily event
// If every_weekday is checked, don't count weends
//=============================================================================
function getDailyEventStartDate(start_date, recurenceObject) {

  if (recurenceObject.everyWeekDayChecked) {
    var day_number_in_week = moment(start_date);
    var dow = day_number_in_week.day();
    if (dow == 0) {
      start_date = moment(start_date).add(1, 'days');
    } else if (dow == 6) {
      start_date = moment(start_date).add(2, 'days');
    }
  }

  return start_date;
}

//=============================================================================
// get order of selected day, should it appear every week (zero for 'every',...) or the first day in a month ('1' for 'first',...)
//=============================================================================
function getOrder(recurenceObject) {
  var whichOrder = ['every', 'first', 'second', 'third', 'fourth', 'fifth', 'last'];
  var order = whichOrder.indexOf(recurenceObject.when[0]);
  return order;
}

//=============================================================================
// Get the next date the event should appear
//=============================================================================
function getTheNextEventDate(previousEventDate, order, recurenceObject) {

  previousEventDate = new Date(previousEventDate);
  var start_date;

  var daysInMonth = moment(previousEventDate).daysInMonth();
  var diffDays = daysInMonth - moment(previousEventDate).date();
  var modulu = diffDays % 7;
  modulu = 7 - modulu;

  if (modulu == 0) {
    if (order == 0) {
      start_date = moment(previousEventDate).add(diffDays + 7, 'days');
    }

    if (order == 1) {
      start_date = moment(previousEventDate).add(diffDays + 7, 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }

    if (order > 1) {
      start_date = moment(previousEventDate).add(diffDays + 7 + ((order - 1) * 7), 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }
  }

  if (modulu > 0) {
    if (order == 0) {
      start_date = moment(previousEventDate).add(diffDays + modulu, 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }

    if (order == 1) {
      start_date = moment(previousEventDate).add(diffDays + modulu, 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }

    if (order > 1) {
      start_date = moment(previousEventDate).add(diffDays + modulu + ((order - 1) * 7), 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }
  }

  return moment(start_date).format();
}

//=============================================================================
// Get the difference in days between two dates
//=============================================================================
function getTwoDatesDifference(date1, date2) {
  date1 = new Date(date1);
  date2 = new Date(date2);
  var timeDiff = Math.abs(date2.getTime() - date1.getTime());
  var diffHours = Math.ceil(timeDiff / (1000 * 3600));
  return diffHours;
}

//=============================================================================
// Find the next date for the event after 1 month, 2, 3,...
//=============================================================================
function getDateAfterNumberOfMonths(currentDate, numberOfMonths, order) {

  if (numberOfMonths == 0) {
    weekNumber = Math.ceil(moment(currentDate).date() / 7);
  }

  new_date = moment(currentDate);

  for (var i = 0; i < numberOfMonths; i++) {
    var daysInMonth = moment(new_date).daysInMonth();
    var diffDays = daysInMonth - moment(new_date).date();
    var modulu = diffDays % 7;
    modulu = 7 - modulu;
    var addDays = diffDays + modulu;
    var new_date = moment(new_date).add(addDays, 'days');
    var weekNumber = Math.ceil(moment(new_date).date() / 7);
    if (order > weekNumber) {
      addDays = order - weekNumber;
      new_date = moment(new_date).add(addDays * 7, 'days');
    }
  }

  return new_date;
}

//=============================================================================
// Get number of days to the next event date
//=============================================================================
function getNumberOfDaysToNewDate(currentDate, numberOfMonths, order) {

  for (var i = 0; i < numberOfMonths; i++) {
    var daysInMonth = moment(currentDate).daysInMonth();
    var diffDays = daysInMonth - moment(currentDate).date();
    var modulu = diffDays % 7;
    modulu = 7 - modulu;
    var addDays = diffDays + modulu + ((order - 1) * 7);
    var new_date = moment(currentDate).add(addDays, 'days');
  }

  return new_date;
}

//=============================================================================
// Sort function
//=============================================================================
function sortArray(a, b) {
  const startDateA = a.startDate.toUpperCase();
  const startDateB = b.startDate.toUpperCase();

  let comparison = 0;
  if (startDateA > startDateB) {
    comparison = 1;
  } else if (startDateA < startDateB) {
    comparison = -1;
  }
  return comparison;
}
//=============================================================================
// Check date validity...
//=============================================================================
function dateIsValid(selectedDay, month, year) {
  var date = moment([year, month, 1]);
  var daysInMonth = moment(date).daysInMonth();
  if (selectedDay <= daysInMonth) {
    return true;
  }
  return false;
}
//==================================================================
function getDurationInUnits(eventDurationHours, durationUnits) {
  var duration;

  switch (durationUnits) {
    case 'day':
      duration = (eventDurationHours / 24);
      //duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
      duration = Math.round(eventDurationHours * 60);
      break;
    default:
      duration = Math.round(eventDurationHours * 60);
  }
  return duration;
} // End of getDurationInUnits

//==================================================================
function getNumberOfWeekDaysNoWeekends(firstDate, lastDate, howOften) {

  var numberOfDays = 0;
  while (moment(firstDate).format("YYYY-MM-DD") <= moment(lastDate).format("YYYY-MM-DD")) {
    firstDate = moment(firstDate);
    var dayOfWeekNumber = firstDate.day();
    if (dayOfWeekNumber == 0 || dayOfWeekNumber == 6) {
      firstDate = moment(firstDate).add(howOften, 'days');
    } else {
      firstDate = moment(firstDate).add(howOften, 'days');
      numberOfDays++;
    }
  }

  return numberOfDays;
}
//==================================================================
// Add time to the endDate extracted from startDate
//==================================================================
function setTimeForEndate(startDate, endDate) {

  endDate = new Date(endDate);
  var end_year = endDate.getFullYear();
  var end_month = endDate.getMonth();
  var date = endDate.getDate();
  var startMinutes = moment(startDate).format("HH:mm");

  endDate = moment([end_year, end_month, date]);
  endDate = moment(endDate).format("YYYY-MM-DD") + "T" + startMinutes;

  return endDate;
}
//==================================================================
// Get First Occurrence Of a certain Day...
//==================================================================
function getFirstOccurrenceOfDay(date, weekDayNumberToFind) {

  var firstDateOfMonth = moment(date).startOf('month').format();
  var firstDateOfMonthNumber = moment(firstDateOfMonth).day();
  var newDate = new Date(firstDateOfMonth);
  var newDayNumber = firstDateOfMonthNumber;
  var numberOfDaysInMonth = moment(date).daysInMonth();

  for (var i = 1; i <= numberOfDaysInMonth; i++) {
    if (newDayNumber == weekDayNumberToFind) {
      if (moment(newDate).format("YYYY-MM-DD") < moment(date).format("YYYY-MM-DD")) {
        newDate = moment(date).add(1, 'month').format();
        newDate = moment(newDate).startOf('month').format("YYYY-MM-DD");
        newDayNumber = moment(newDate).day();
        numberOfDaysInMonth = moment(date).daysInMonth();
        i = 0;
        continue;
      } else if (moment(newDate).format("YYYY-MM-DD") >= moment(date).format("YYYY-MM-DD")) {
        var extractedTime = moment(date).format("HH:mm");
        newDate = moment(newDate).format("YYYY-MM-DD");
        newDate = newDate + " " + extractedTime;
        return moment(newDate).format();
      } else {
        return false;
      }
    }
    newDate = moment(newDate).add(1, 'days').format();
    newDayNumber = moment(newDate).day();
  }
  return false;

}
//==================================================================
// Take the selected date/time and prepare a string including the
// selected time and timezone...
//==================================================================
FullcalendarTimeline.prototype.prepareTimeAndTimeZone = function () {

  var startingDate = this._formData.start_date_with_timezone;
  var tzStr = (startingDate).substring(25 - 6);
  var startTimeZone = this._formData.resource_planner_event_dtstart_timezone;
  moment.tz.setDefault(startTimeZone);
  var timeStr = "T" + moment(startingDate).format("HH:mm:ss");
  var partOfDate = timeStr + tzStr;

  return partOfDate;
}
