require_dependency 'resource_planner/application_controller'

module ResourcePlanner
  class ResourcesController < ApplicationController

    # GET /resource_planner/list.json
    def list
      @resources = {}
      get_resource_models.each do |resource_model|
        resource_model_data = if resource_model[:data_query].nil? || resource_model[:data_query].empty?
                                resource_model[:model].constantize.all
                              else
                                eval(resource_model[:data_query])
                              end

        @resources[resource_model] = resource_model_data
      end

      respond_to do |format|
        format.html # list.html.erb
        #format.html { render ('list.html.erb') }
        format.xml  { render :xml => @resources }
        format.json { render 'list.json.jbuilder' }
        #format.json { render :json => @resources }
      end
    end

    # GET /resource_planner/events.json
    # GET /resource_events.json
    def events
      @resource_models = get_resource_models
      @application_preferences = get_application_preferences
      @events = ::ResourcePlanner::Event.events

      respond_to do |format|
        format.html # events.html.erb
        #format.html { render ('events.html.erb') }
        format.xml  { render :xml => @events }
        format.json { render 'events.json.jbuilder' }
        #format.json { render :json => @events }
      end
    end

    # GET /resource_planner/restrictions.json
    # GET /resource_restrictions.json
    def restrictions
      @resource_models = get_resource_models
      @application_preferences = get_application_preferences
      @events = ::ResourcePlanner::Event.resource_restrictions

      respond_to do |format|
        format.html # events.html.erb
        #format.html { render ('restrictions.html.erb') }
        format.xml  { render :xml => @events }
        format.json { render 'restrictions.json.jbuilder' }
        #format.json { render :json => @events }
      end
    end
  end
end
