@events.each do |event|
  json.array!(event.event_units) do |event_unit|
    date_format = event_unit.all_day? ? '%Y-%m-%d%:z' : '%Y-%m-%dT%H:%M:%S%:z'

    json.extract! event_unit, :id
    json.title event_unit.name.nil? || event_unit.name.empty? ? event.name : event.name + '(' + event_unit.name + ')'
    json.description event.description
    json.allDay event_unit.all_day?
    json.start event_unit.start_at.strftime(date_format) if event_unit.start_at
    json.end event_unit.end_at.strftime(date_format) if event_unit.end_at
    #json.url event_url(event, :format => :html)
    json.url event_url(event, :format => :json)

    #json.className
    #json.editable
    #json.startEditable
    #json.durationEditable
    #json.resourceEditable
    #json.rendering
    #json.overlap
    #json.constraint
    #json.color
    #json.backgroundColor
    #json.borderColor
    #json.textColor

    # resourceIds is used by FullCalendar so, we need 2 separate arrays
    resource_ids = []
    resource_allocation = []

    event_unit.subscriptions.each do |event_subscription|
      resource_ids.push("#{event_subscription.resource_type}-#{event_subscription.resource.id}-#{event_subscription.resource.quantity}")
      resource_allocation.push(
        {
          'maximumAvailable' => event_subscription.resource.quantity,
          'allocated' => event_subscription.quantity
        }
      )
    end

    json.resourceIds resource_ids
    json.resourceAllocation resource_allocation
  end
end
