ResourcePlanner::Engine.routes.draw do
  scope ':view', :as => :alternate do
    resources :events
  end

  resources :events do
    resources :event_units
  end

  get 'event_units/events', :as => 'event_units_for_events'
  get 'event_units/resource_availabilities', :as => 'event_units_for_resource_availabilities'
  get 'event_units/resource_restrictions', :as => 'event_units_for_resource_restrictions'
  resources :event_units

  get 'resources' => 'resources#list', :as => 'resources'
  get 'resources/list', :as => 'resource_list'
  get 'resource_events' => 'resources#events', :as => 'resource_events'
  get 'resources/events', :as => 'resource_event_list'
  get 'resource_restrictions' => 'resources#restrictions', :as => 'resource_restrictions'
  get 'resources/restrictions', :as => 'resource_restrictions_list'

  # namespace :resource_planner do
  #   get 'resources/list'
  #   get 'resources/events'
  # end

  #get 'resource_list'   => 'resources/resource_list'
  #get 'resource_events' => 'resources/resource_events'

  get 'application_preferences/all'

  get 'overview' => 'overview/index'

  root :to => 'events#index'
end
